/*
 * CaseResult class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.tester.coverage;

import java.util.Set;
import java.util.TreeSet;
import java.util.List;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Collections;

/**
 * ̃JobWvʃIuWFNgO[vāAʐʉߐ 
 * Wv邽߂̃NXB
 *
 * @author  V. 
 * @version $Revision: 1.2 $, $Date: 2007/02/16 16:12:48 $
 */
public class CaseResult<K> extends Result<K>
{
  /** ěʃIuWFNgB */
  private Result<K> parentResult_ ;

  /** ̃P[XΏۂƂ錋ʃL[i[ZbgB */
  private Set<K> keySet_ = new TreeSet<K>();

  /**
   * ěʃIuWFNgɂƂRXgN^B
   * <br>
   * ŏʂ̌ʃIuWFNg{@link ts.tester.coverage.PassResult PassResult}
   * IuWFNgɂȂB
   *
   * @param  result ěʃIuWFNgB
   */
  public CaseResult(Result<K> result)
  {
    assert (result != null) : "@param:result is null.";

    parentResult_ = result;
  }

  /**
   * ʉ߉񐔂i[錋ʃIuWFNgǍʃL[ɑΉÂēo^B
   * <br>
   * łʃL[Ƃ́AႦ΍sJobWvꍇȂ΍sԍ
   * ȂǂłB
   * <br>
   * ̃L[ɑΉ錋ʃIuWFNgɓo^Ăꍇ͉ȂB
   *
   * @param  resultKey ʃL[B
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  @Override public void addResult(K resultKey)
  {
    parentResult_.addResult(resultKey);
    keySet_.add(resultKey);
  }

  /**
   * ̃IuWFNgi[ĂSʐ擾B
   *
   * @return SʐB
   */
  @Override public int countAllResults()
  {
    return keySet_.size();
  }

  /**
   * ̃IuWFNgi[Ăʉߍς݂̌ʐ擾B
   *
   * @return ʉߍς݂̌ʐB
   */
  @Override public int countPassedResults()
  {
    int count = 0;
    for (K key : keySet_) {
      if (parentResult_.getPassCountOfResult(key) > 0) {
        count ++;
      }
    }
    return count;
  }

  /**
   * ̌ʃL[ɑΉ錋ʃIuWFNgʉߐPZB
   * <br>
   * ̌ʃL[ɑΉ錋ʃIuWFNg݂Ȃꍇ͉ȂB
   *
   * @param  resultKey ʃL[B
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  @Override public void incrementPassCountOfResult(K resultKey)
  {
    assert (resultKey != null) : "@param:resultKey is null.";

    parentResult_.incrementPassCountOfResult(resultKey);
  }

  /**
   * ̃L[ɑΉP[Xv̑ΏۂǂmFB
   * <br>
   * v̑Ώۂłꍇ́A<tt>true</tt>ԂB
   *
   * @param  resultKey P[X̃L[B
   * @return ̃L[ɑΉP[Xv̑Ώۂłꍇ<tt>true</tt>B
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  @Override public boolean containsKeyOfResult(K resultKey)
  {
    return parentResult_.containsKeyOfResult(resultKey);
  }

  /**
   * ̌ʃL[ɑΉ錋ʃIuWFNg̒ʉߐ擾B
   * <br>
   * ̌ʃL[ɑΉ錋ʃIuWFNg݂Ȃꍇ̓[ԂB
   *
   * @param  resultKey ʃL[B
   * @return ʉߐB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  @Override public int getPassCountOfResult(K resultKey)
  {
    return parentResult_.getPassCountOfResult(resultKey);
  }

  /**
   * ̃IuWFNgɊi[ĂSĂ̌ʃL[i[񋓃IuWFNg
   * ԂB
   *
   * @return SČʃL[i[񋓃IuWFNgB
   */
  @Override public Enumeration<K> enumAllResultKeys()
  {
    return Collections.enumeration(keySet_);
  }

  /**
   * ʉߍς݂̌ʃIuWFNǧʃL[i[񋓃IuWFNgԂB
   *
   * @return ʉߍς݂̌ʃIuWFNg̃L[i[񋓃IuWFNgB
   */
  @Override public Enumeration<K> enumPassedResultKeys()
  {
    List<K> keyLst = new ArrayList<K>(keySet_.size());
    for (K key : keySet_) {
      if (parentResult_.getPassCountOfResult(key) > 0) {
        keyLst.add(key);
      }
    }
    return Collections.enumeration(keyLst);
  }

  /**
   * ʉ߂̌ʃIuWFNǧʃL[i[񋓃IuWFNgԂB
   *
   * @return ʉ߂̌ʃIuWFNg̃L[i[񋓃IuWFNgB
   */
  @Override public Enumeration<K> enumNotPassedResultKeys()
  {
    List<K> keyLst = new ArrayList<K>(keySet_.size());
    for (K key : keySet_) {
      if (parentResult_.getPassCountOfResult(key) <= 0) {
        keyLst.add(key);
      }
    }
    return Collections.enumeration(keyLst);
  }
}
