/*
 * AbstractPrinter class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.tester.function.print;

import ts.tester.function.CaseResult;
import ts.tester.function.CheckResult;

/**
 * ʏo͂̂߂̒ۃNXB 
 * <br>
 * o͕@ɍ{@link ts.tester.function.CaseResult CaseResult}IuWFNg
 * ̍쐬ƁA̍ŏI茋ʂo͂邽߂̃\bh錾ĂB
 *
 * @author  V. 
 * @version $Revision: 1.2 $, $Date: 2007/02/16 16:12:51 $
 */
public abstract class AbstractPrinter implements Printer
{
  /** 𒆒f邩ǂtOB */
  private boolean isStopped_ = false;

  /**
   * ftHgRXgN^B
   */
  public AbstractPrinter()
  {}

  /**
   * 𒆒f邩ǂݒ肷B
   *
   * @param  isStopped 𒆒fꍇ<tt>true</tt>ݒ肷B
   */
  public void setStopped(boolean isStopped)
  {
    isStopped_ = isStopped;
  }

  /**
   * 𒆒f邩ǂ𔻒肷B
   *
   * @return  𒆒fꍇ<tt>true</tt>ԂB
   */
  public boolean isStopped()
  {
    return isStopped_ ;
  }

  /**
   * Ŝ̊JnɌĂяo郁\bhB
   *
   * @param  root ŏʂ̎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void testStarted(CaseResult root)
  {
    assert (root != null) : "@param:root is null.";
  }

  /**
   * Ŝ̏IɌĂяo郁\bhB
   *
   * @param  root ŏʂ̎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void testEnded(CaseResult root)
  {
    assert (root != null) : "@param:root is null.";
  }

  /**
   * P[X̊JnɌĂяo郁\bhB
   *
   * @param  current Jn鎎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void caseStarted(CaseResult current)
  {
    assert (current != null) : "@param:current is null.";
  }

  /**
   * P[X̏IɌĂяo郁\bhB
   *
   * @param  current I鎎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void caseEnded(CaseResult current)
  {
    assert (current != null) : "@param;current is null.";
  }

  /**
   * 肪sꂽɌĂяo郁\bhB
   *
   * @param  check 茋ʃIuWFNgB
   * @param  current ݂̎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void checkOccured(CheckResult check, CaseResult current)
  {
    assert (check != null) : "@param;check is null.";
    assert (current != null) : "@param;current is null.";
  }

  /**
   * bZ[W̓o^ꍇɌĂяo郁\bhB
   *
   * @param  msg o^郁bZ[WB
   * @param  current ݂̎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void messageNoted(String msg, CaseResult current)
  {
    assert (msg != null) : "@param:msg is null.";
    assert (current != null) : "@param:current is null.";
  }

  /**
   * ̒fɌĂяo郁\bhB
   *
   * @param  current ݂̎P[X茋ʃIuWFNgB
   * @throws AssertionError k̏ꍇifobO[ĥ݁jB
   */
  public void testStopped(CaseResult current)
  {
    assert (current != null) : "@param:current is null.";
  }
}
